# Условие: имаме стойностите на картини (> 0). Не можем да взимаме съседни картини. Колко е максималната стойност?

def thief(paintings):
	n = len(paintings)
	answer = [0 for x in range(n)]
	taken = [False for x in range(n)] # за възстановяване

	# началото попълваме ръчно за да си спестим малко код в цикъла
	answer[0] = paintings[0]
	taken[0] = True

	if paintings[0] > paintings[1]:
		answer[1] = paintings[0]
		taken[1] = False
	else:
		answer[1] = paintings[1]
		taken[1] = True

	for i in range(2,n):
		if answer[i - 1] > answer[i - 2] + paintings[i]:
			answer[i] = answer[i - 1]
			taken[i] = False
		else:
			answer[i] = answer[i - 2] + paintings[i]
			taken[i] = True

	pos = n - 1
	takenList = []

	while pos >= 0:
		if taken[pos]:
			takenList.append(pos)
			pos -= 2
		else:
			pos -= 1

	return answer[n - 1], takenList

# приемаме, че има поне 2 картини
def thiefConstantMemory(paintings):
	n = len(paintings)

	secondLast = paintings[2]
	last = max(paintings[0], paintings[1])

	for i in range(2, n):
		new = max(last, secondLast + paintings[i])
		secondLast = last
		last = new

	return last

paintings = [3,10,5,6,11]
profit, taken = thief(paintings)

print(thiefConstantMemory(paintings))
print(profit)
print(taken)
