# Условие: сума на най-малко колко квадрата дава N?

def findBestSquareSum(n):
	answer = [0 for i in range(n+1)]
	lastNumberUsed = [None for i in range(n+1)]

	for i in range(1, n+1):
		best = n + 1 # това е ефективно безкрайност, защото най-много да се направи сума от 1-ци
		j = 1

		# проверяваме всички възможни квадрати
		while j*j <= i: 
			diff = i - j*j
			if answer[diff] < best:
				best = answer[diff]
				lastNumberUsed[i] = j
			j += 1
		answer[i] = best + 1

	# възстановяване на решението
	numbers = []
	num = n

	while num > 0:
		k = lastNumberUsed[num]
		numbers.append(k)
		num -= k*k

	return answer[n], numbers

minCount, numbers = findBestSquareSum(18)
print(minCount)
print(numbers)