# Условие: имаме 3 масива A,B и C, които имат N положителни числа. За всяко i от 1 до N трябва да изберем
# елемент от точно един масив на тази позиция. Не можем последователно да вземем от един и същ масив.
# Каква е максималната сума, която можем да постигнем?

def thief3(a, b, c):
	n = len(a) # примеме че всички масиви са с еднаква дължина
	
	arrs = [a,b,c] # за да може да ползваме индекси вместо да повтаряме кода 3 пъти

	answer = [ [0,0,0] for i in range(n) ]
	where = [ [None, None, None] for i in range(n) ]
	for i in range(3): answer[0][i] = arrs[i][0]

	for i in range(1,n):
		for j in range(3):
			arr1 = (j + 1) % 3 # това ни дава индексите
			arr2 = (j + 2) % 3 # на другите два масива

			answer[i][j] = arrs[j][i]

			if answer[i - 1][arr1] > answer[i - 1][arr2]:
				answer[i][j] += answer[i - 1][arr1]
				where[i][j] = arr1
			else:
				answer[i][j] += answer[i - 1][arr2]
				where[i][j] = arr2

	bestColumn = 0
	if answer[n - 1][1] > answer[n - 1][bestColumn]:
		bestColumn = 1
	if answer[n - 1][2] > answer[n - 1][bestColumn]:
		bestColumn = 2

	# възстановяване
	order = [bestColumn]
	current = bestColumn
	for i in range(n - 1, 0, -1): # n-1 до 0
		new = where[i][bestColumn]
		order.append(new)
		current = new

	return answer[n - 1][bestColumn], order

a = [6, 20, 11, 16, 13, 17, 9]
b = [4, 11, 5, 2, 13, 6, 8]
c = [15, 3, 20, 17, 13, 8, 5]

ans, order = thief3(a, b, c)
print(ans)
print(order[::-1])
		